#--
# $Id: source.rb 49 2005-06-09 17:21:05Z tilman $
#
# Copyright (c) 2005 Tilman Sauerbeck (tilman at code-monkey de)
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

module Redact
	class SourceFile
		attr_reader :filename, :contents

		def initialize(filename, contents)
			@filename = filename.to_str.dup.freeze
			@contents = contents.to_str.dup.freeze
		end

		def to_eet_name
			"srcfile"
		end

		def to_eet_properties
			{"name" => [@filename],
			 "file" => [@contents]}
		end
	end

	class SourceFiles < Array
		def to_eet_name
			"srcfile_list"
		end

		def to_eet_properties
			{"list" => [self]}
		end
	end

	class FontMapEntry
		def initialize(font)
			@font = font
		end

		def to_eet_name
			"font"
		end

		def to_eet_properties
			{"file" => [@font.save_as],
			 "name" => [@font.alias]}
		end
	end

	class FontMap < Array
		def to_eet_name
			"font_list"
		end

		def to_eet_properties
			{"list" => [self]}
		end
	end
end
